Search:

# CWIS Developers Documentation

- Main Page
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# MetadataSchema Class Reference

Inheritance diagram for MetadataSchema:

[legend]
Collaboration diagram for MetadataSchema:

[legend]
List of all members.

## Public Member Functions
| MetadataSchema ()
| CacheData ($NewValue)
| AddField ($FieldName, $FieldType, $Optional=TRUE, $DefaultValue=NULL)
| AddFieldFromXml ($Xml)
| Add new metadata field based on supplied XML.
| DropField ($FieldId)
| GetField ($FieldId)
| GetFieldByName ($FieldName, $IgnoreCase=FALSE)
| Retrieve metadata field by name.
| GetFieldByLabel ($FieldLabel, $IgnoreCase=FALSE)
| Retrieve metadata field by label.
| GetFieldIdByName ($FieldName, $IgnoreCase=FALSE)
| Retrieve metadata field ID by name.
| GetFieldIdByLabel ($FieldLabel, $IgnoreCase=FALSE)
| Retrieve metadata field ID by label.
| FieldExists ($FieldName)
| GetFields ($FieldTypes=NULL, $OrderType=NULL, $IncludeDisabledFields=FALSE, $IncludeTempFields=FALSE)
| CompareFieldOrder ($FieldA, $FieldB)
| GetFieldNames ($FieldTypes=NULL, $OrderType=NULL, $IncludeDisabledFields=FALSE, $IncludeTempFields=FALSE)
| GetFieldsAsOptionList ($OptionListName, $FieldTypes=NULL, $SelectedFieldId=NULL, $IncludeNullOption=TRUE, $AddEntries=NULL, $AllowMultiple=FALSE)
| Retrieve fields of specified type as HTML option list with field names as labels and field IDs as value attributes.
| GetFieldTypes ()
| GetAllowedFieldTypes ()
| RemoveQualifierAssociations ($QualifierIdOrObject)
| QualifierIsInUse ($QualifierIdOrObject)
| MoveUpInOrder ($FieldIdOrObj, $OrderType)
| MoveDownInOrder ($FieldIdOrObj, $OrderType)
| GetHighestFieldId ()
| GetFieldByMappedName ($MappedName)
| Get field by standard field name.
| GetOwnedFields ()
| Get fields that have an owner associated with them.
## Static Public Member Functions
static | StdNameToFieldMapping ($MappedName, $FieldId=NULL)
| Get/set mapping of standard field name to specific field.
static | FieldToStdNameMapping ($FieldId)
| Get mapping of field ID to standard field name.
static | SetOwnerListRetrievalFunction ($Callback)
| Allow external dependencies, i.e., the current list of owners that are available, to be injected.
static | NormalizeOwnedFields ()
| Disable owned fields that have an owner that is unavailable and re-enable fields if an owner has returned and the field was flagged to be re-enabled.
## Public Attributes
const | MDFORDER_DISPLAY = 1
const | MDFORDER_EDITING = 2
const | MDFORDER_ALPHABETICAL = 3
const | MDFTYPE_TEXT = 1
const | MDFTYPE_PARAGRAPH = 2
const | MDFTYPE_NUMBER = 4
const | MDFTYPE_DATE = 8
const | MDFTYPE_TIMESTAMP = 16
const | MDFTYPE_FLAG = 32
const | MDFTYPE_TREE = 64
const | MDFTYPE_CONTROLLEDNAME = 128
const | MDFTYPE_OPTION = 256
const | MDFTYPE_USER = 512
const | MDFTYPE_IMAGE = 1024
const | MDFTYPE_FILE = 2048
const | MDFTYPE_URL = 4096
const | MDFTYPE_POINT = 8192
const | MDFSTAT_OK = 1
const | MDFSTAT_ERROR = 2
const | MDFSTAT_DUPLICATENAME = 4
const | MDFSTAT_DUPLICATEDBCOLUMN = 8
const | MDFSTAT_FIELDDOESNOTEXIST = 16
const | MDFSTAT_ILLEGALNAME = 32
const | MDFSTAT_DUPLICATELABEL = 64
const | MDFSTAT_ILLEGALLABEL = 128
## Static Protected Attributes
static | $OwnerListRetrievalFunction

## Detailed Description

Definition at line 10 of file MetadataSchema.php.

## Member Function Documentation

MetadataSchema::AddField | ( | $ | FieldName,
|  | $ | FieldType,
|  | $ | Optional = `TRUE`,
|  | $ | DefaultValue = `NULL` |
| ) |  |  |

Definition at line 65 of file MetadataSchema.php.

References MDFSTAT_OK, and ItemFactory::Status().

MetadataSchema::AddFieldFromXml | ( | $ | Xml | ) |

Add new metadata field based on supplied XML.

The XML elements are method names from the MetadataField object, with the values being passed in as the parameter to that method. The FieldName and FieldType elements are required. Values for elements/methods that would normally be called with constants in PHP can be constant names.

Parameters:

  | Xml | Block of XML containing field description.

Returns:
  New MetadataField object or MDFSTAT_ error code if addition failed.

Definition at line 90 of file MetadataSchema.php.

References ItemFactory::Status().

MetadataSchema::CacheData | ( | $ | NewValue | ) |

Definition at line 59 of file MetadataSchema.php.

MetadataSchema::CompareFieldOrder | ( | $ | FieldA,
|  | $ | FieldB |
| ) |  |  |

Definition at line 316 of file MetadataSchema.php.

References MDFORDER_ALPHABETICAL.

MetadataSchema::DropField | ( | $ | FieldId | ) |

Definition at line 153 of file MetadataSchema.php.

References ItemFactory::$FieldId.

MetadataSchema::FieldExists | ( | $ | FieldName | ) |

Definition at line 250 of file MetadataSchema.php.

References ItemFactory::NameIsInUse().

static MetadataSchema::FieldToStdNameMapping | ( | $ | FieldId | ) | `[static]`

Get mapping of field ID to standard field name.

Parameters:

  | FieldId | Field ID.

Returns:
  Standard field name to which specified field is mapped, or NULL if field is not currently mapped.

Definition at line 513 of file MetadataSchema.php.

References ItemFactory::$FieldId.

MetadataSchema::GetAllowedFieldTypes | ( |  | ) |

Definition at line 439 of file MetadataSchema.php.

References MetadataField::$FieldTypeDBAllowedEnums.

MetadataSchema::GetField | ( | $ | FieldId | ) |

Definition at line 160 of file MetadataSchema.php.

References ItemFactory::$FieldId.

Referenced by GetFieldByLabel(), GetFieldByMappedName(), GetFieldByName(), GetFields(), GetFieldsAsOptionList(), and GetOwnedFields().

Here is the caller graph for this function:

MetadataSchema::GetFieldByLabel | ( | $ | FieldLabel,
|  | $ | IgnoreCase = `FALSE` |
| ) |  |  |

Retrieve metadata field by label.

Parameters:

  | FieldLabel | Field label.
  | IgnoreCase | If TRUE, case is ignore when matching field labels.

Returns:
  Requested MetadataField or NULL if no field found with specified label.

Definition at line 193 of file MetadataSchema.php.

References ItemFactory::$FieldId, GetField(), and GetFieldIdByLabel().

MetadataSchema::GetFieldByMappedName | ( | $ | MappedName | ) |

Get field by standard field name.

Parameters:

  | MappedName | Standard field name.

Returns:
  MetadataField to which standard field name is mapped or NULL if specified standard field name is not currently mapped or mapped field does not exist.

Definition at line 535 of file MetadataSchema.php.

References GetField(), and StdNameToFieldMapping().

MetadataSchema::GetFieldByName | ( | $ | FieldName,
|  | $ | IgnoreCase = `FALSE` |
| ) |  |  |

Retrieve metadata field by name.

Parameters:

  | FieldName | Field name.
  | IgnoreCase | If TRUE, case is ignore when matching field names.

Returns:
  Requested MetadataField or NULL if no field found with specified name.

Definition at line 181 of file MetadataSchema.php.

References ItemFactory::$FieldId, GetField(), and GetFieldIdByName().

MetadataSchema::GetFieldIdByLabel | ( | $ | FieldLabel,
|  | $ | IgnoreCase = `FALSE` |
| ) |  |  |

Retrieve metadata field ID by label.

Parameters:

  | FieldLabel | Field label.
  | IgnoreCase | If TRUE, case is ignore when matching field labels.

Returns:
  ID of requested MetadataField or FALSE if no field found with specified label.

Definition at line 231 of file MetadataSchema.php.

Referenced by GetFieldByLabel().

Here is the caller graph for this function:

MetadataSchema::GetFieldIdByName | ( | $ | FieldName,
|  | $ | IgnoreCase = `FALSE` |
| ) |  |  |

Retrieve metadata field ID by name.

Parameters:

  | FieldName | Field name.
  | IgnoreCase | If TRUE, case is ignore when matching field names.

Returns:
  ID of requested MetadataField or FALSE if no field found with specified name.

Definition at line 206 of file MetadataSchema.php.

Referenced by GetFieldByName().

Here is the caller graph for this function:

MetadataSchema::GetFieldNames | ( | $ | FieldTypes = `NULL`,
|  | $ | OrderType = `NULL`,
|  | $ | IncludeDisabledFields = `FALSE`,
|  | $ | IncludeTempFields = `FALSE` |
| ) |  |  |

Definition at line 338 of file MetadataSchema.php.

References ItemFactory::$DB, and GetFields().

Referenced by GetFieldsAsOptionList().

Here is the caller graph for this function:

MetadataSchema::GetFields | ( | $ | FieldTypes = `NULL`,
|  | $ | OrderType = `NULL`,
|  | $ | IncludeDisabledFields = `FALSE`,
|  | $ | IncludeTempFields = `FALSE` |
| ) |  |  |

Definition at line 253 of file MetadataSchema.php.

References MetadataField::$FieldTypePHPEnums, and GetField().

Referenced by GetFieldNames().

Here is the caller graph for this function:

MetadataSchema::GetFieldsAsOptionList | ( | $ | OptionListName,
|  | $ | FieldTypes = `NULL`,
|  | $ | SelectedFieldId = `NULL`,
|  | $ | IncludeNullOption = `TRUE`,
|  | $ | AddEntries = `NULL`,
|  | $ | AllowMultiple = `FALSE` |
| ) |  |  |

Retrieve fields of specified type as HTML option list with field names as labels and field IDs as value attributes.

The first element on the list will have a label of "--" and an ID of -1 to indicate no field selected.

Parameters:

  | OptionListName | Value of option list "name" and "id" attributes.
  | FieldTypes | Types of fields to return. (OPTIONAL - use NULL for all types)
  | SelectedFieldId | ID or array of IDs of the currently-selected field(s). (OPTIONAL)
  | IncludeNullOption | Whether to include "no selection" (-1) option. (OPTIONAL - defaults to TRUE)
  | AddEntries | An array of additional entries to include at the end of the option list, with option list values for the indexes and option list labels for the values. (OPTIONAL)
  | AllowMultiple | TRUE to allow multiple field selections

Returns:
  HTML for option list.

Definition at line 370 of file MetadataSchema.php.

References ItemFactory::$FieldId, GetField(), and GetFieldNames().

MetadataSchema::GetFieldTypes | ( |  | ) |

Definition at line 433 of file MetadataSchema.php.

References MetadataField::$FieldTypeDBEnums.

MetadataSchema::GetHighestFieldId | ( |  | ) |

Definition at line 488 of file MetadataSchema.php.

References ItemFactory::GetHighestItemId().

MetadataSchema::GetOwnedFields | ( |  | ) |

Get fields that have an owner associated with them.

Returns:
  an array of fields that have an owner associated with them

Definition at line 545 of file MetadataSchema.php.

References ItemFactory::$FieldId, and GetField().

MetadataSchema::MetadataSchema | ( |  | ) |

Definition at line 48 of file MetadataSchema.php.

References ItemFactory::ItemFactory().

Referenced by NormalizeOwnedFields().

Here is the caller graph for this function:

MetadataSchema::MoveDownInOrder | ( | $ | FieldIdOrObj,
|  | $ | OrderType |
| ) |  |  |

Definition at line 482 of file MetadataSchema.php.

MetadataSchema::MoveUpInOrder | ( | $ | FieldIdOrObj,
|  | $ | OrderType |
| ) |  |  |

Definition at line 478 of file MetadataSchema.php.

static MetadataSchema::NormalizeOwnedFields | ( |  | ) | `[static]`

Disable owned fields that have an owner that is unavailable and re-enable fields if an owner has returned and the field was flagged to be re-enabled.

Definition at line 580 of file MetadataSchema.php.

References MetadataSchema().

MetadataSchema::QualifierIsInUse | ( | $ | QualifierIdOrObject | ) |

Definition at line 457 of file MetadataSchema.php.

MetadataSchema::RemoveQualifierAssociations | ( | $ | QualifierIdOrObject | ) |

Definition at line 445 of file MetadataSchema.php.

static MetadataSchema::SetOwnerListRetrievalFunction | ( | $ | Callback | ) | `[static]`

Allow external dependencies, i.e., the current list of owners that are available, to be injected.

Parameters:

  | $Callback | retrieval callback

Definition at line 567 of file MetadataSchema.php.

static MetadataSchema::StdNameToFieldMapping | ( | $ | MappedName,
|  | $ | FieldId = `NULL` |
| ) |  |  | `[static]`

Get/set mapping of standard field name to specific field.

Parameters:

  | MappedName | Standard field name.
  | FieldId | ID of field to map to. (OPTIONAL)

Returns:
  ID of field to which standard field name is mapped or NULL if specified standard field name is not currently mapped.

Definition at line 497 of file MetadataSchema.php.

References ItemFactory::$FieldId.

Referenced by GetFieldByMappedName().

Here is the caller graph for this function:

## Member Data Documentation

MetadataSchema::$OwnerListRetrievalFunction`[static, protected]`

Definition at line 646 of file MetadataSchema.php.

const MetadataSchema::MDFORDER_ALPHABETICAL = 3

Definition at line 17 of file MetadataSchema.php.

Referenced by CompareFieldOrder().

const MetadataSchema::MDFORDER_DISPLAY = 1

Definition at line 15 of file MetadataSchema.php.

Referenced by MetadataField::MetadataField(), and MetadataField::OrderPosition().

const MetadataSchema::MDFORDER_EDITING = 2

Definition at line 16 of file MetadataSchema.php.

Referenced by MetadataField::MetadataField(), and MetadataField::OrderPosition().

const MetadataSchema::MDFSTAT_DUPLICATEDBCOLUMN = 8

Definition at line 41 of file MetadataSchema.php.

const MetadataSchema::MDFSTAT_DUPLICATELABEL = 64

Definition at line 44 of file MetadataSchema.php.

const MetadataSchema::MDFSTAT_DUPLICATENAME = 4

Definition at line 40 of file MetadataSchema.php.

Referenced by MetadataField::MetadataField(), and MetadataField::Name().

const MetadataSchema::MDFSTAT_ERROR = 2

Definition at line 39 of file MetadataSchema.php.

const MetadataSchema::MDFSTAT_FIELDDOESNOTEXIST = 16

Definition at line 42 of file MetadataSchema.php.

Referenced by MetadataField::MetadataField().

const MetadataSchema::MDFSTAT_ILLEGALLABEL = 128

Definition at line 45 of file MetadataSchema.php.

Referenced by MetadataField::Label().

const MetadataSchema::MDFSTAT_ILLEGALNAME = 32

Definition at line 43 of file MetadataSchema.php.

Referenced by MetadataField::IsTempItem(), and MetadataField::Name().

const MetadataSchema::MDFSTAT_OK = 1

Definition at line 38 of file MetadataSchema.php.

Referenced by AddField(), Resource::Get(), Resource::GetQualifierByField(), ResourceFactory::GetResourceCount(), MetadataField::Label(), MetadataField::MetadataField(), MetadataField::Name(), and SavedSearch::TranslateSearchGroupsToTextDescription().

const MetadataSchema::MDFTYPE_CONTROLLEDNAME = 128

Definition at line 29 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), MetadataField::GetCountOfPossibleValues(), MetadataField::GetFactory(), MetadataField::GetIdForValue(), MetadataField::GetPossibleValues(), Resource::GetQualifierByField(), ResourceFactory::GetResourceCount(), SPTOAIItem::GetSets(), MetadataField::GetValueForId(), SPTOAIItemFactory::LoadSetNameInfo(), MetadataField::MetadataField(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_DATE = 8

Definition at line 25 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), ResourceFactory::GetMatchingResources(), ResourceFactory::GetResourceIdsSortedBy(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_FILE = 2048

Definition at line 33 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_FLAG = 32

Definition at line 27 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), MetadataField::GetCountOfPossibleValues(), ResourceFactory::GetMatchingResources(), MetadataField::GetPossibleValues(), Resource::Resource(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_IMAGE = 1024

Definition at line 32 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), Resource::Delete(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_NUMBER = 4

Definition at line 24 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), ResourceFactory::GetMatchingResources(), ResourceFactory::GetResourceIdsSortedBy(), Resource::Resource(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), SPTSearchEngine::SPTSearchEngine(), and UnitTest().

const MetadataSchema::MDFTYPE_OPTION = 256

Definition at line 30 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::DefaultValue(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), MetadataField::GetCountOfPossibleValues(), MetadataField::GetFactory(), MetadataField::GetIdForValue(), MetadataField::GetPossibleValues(), Resource::GetQualifierByField(), ResourceFactory::GetResourceCount(), SPTOAIItem::GetSets(), MetadataField::GetValueForId(), SPTOAIItemFactory::LoadSetNameInfo(), MetadataField::MetadataField(), Resource::Resource(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_PARAGRAPH = 2

Definition at line 23 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), ResourceFactory::GetMatchingResources(), ResourceFactory::GetResourceIdsSortedBy(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), SPTSearchEngine::SPTSearchEngine(), and UnitTest().

const MetadataSchema::MDFTYPE_POINT = 8192

Definition at line 35 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::DefaultValue(), MetadataField::Drop(), Resource::Get(), ResourceFactory::GetMatchingResources(), Resource::Resource(), Resource::Set(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_TEXT = 1

Definition at line 22 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), ResourceFactory::GetMatchingResources(), ResourceFactory::GetResourceIdsSortedBy(), Resource::Resource(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_TIMESTAMP = 16

Definition at line 26 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), ResourceFactory::GetMatchingResources(), ResourceFactory::GetResourceIdsSortedBy(), Resource::Resource(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_TREE = 64

Definition at line 28 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), MetadataField::GetCountOfPossibleValues(), MetadataField::GetFactory(), MetadataField::GetIdForValue(), MetadataField::GetPossibleValues(), Resource::GetQualifierByField(), SPTOAIItem::GetSets(), MetadataField::GetValueForId(), SPTOAIItemFactory::LoadSetNameInfo(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_URL = 4096

Definition at line 34 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), ResourceFactory::GetMatchingResources(), ResourceFactory::GetResourceIdsSortedBy(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

const MetadataSchema::MDFTYPE_USER = 512

Definition at line 31 of file MetadataSchema.php.

Referenced by Resource::ClearByField(), MetadataField::Drop(), Resource::Get(), MetadataField::GetAllowedConversionTypes(), MetadataField::GetCountOfPossibleValues(), MetadataField::GetPossibleValues(), SPTSearchEngine::SearchFieldForPhrases(), SPTSearchEngine::SearchFieldsForComparisonMatches(), Resource::Set(), SPTRecommender::SPTRecommender(), and SPTSearchEngine::SPTSearchEngine().

The documentation for this class was generated from the following file:

- MetadataSchema.php